package org.clank.java.stdimpl.aliases;

import org.clank.java.*;
import org.clank.support.*;
import org.clank.support.aliases.*;

//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.clank.java/src/org/clank/support/aliases/templates/StdReverseIterator.tpl")
//</editor-fold>
public abstract class ${FILE_NAME}${CLASS_SUFFIX} implements ${INTERFACE_ITERATOR} {
    
    private ${VALUE_ITERATOR} delegate;

    public ${FILE_NAME}(${VALUE_ITERATOR} delegate) {
      this.delegate = delegate;
    }

    @Override
    public ${VALUE_TYPE} $star() {
      return ((${VALUE_ITERATOR}) delegate.$sub(1)).$star();
    }

    @Override
    public int $sub(${STD_DUAL_ITERATOR} iter) {
      throw new UnsupportedOperationException("Not supported.");
    }

    @Override
    public ${STD_DUAL_ITERATOR} $preInc() {
      delegate.$preDec();
      return (${STD_DUAL_ITERATOR}) this;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $preDec() {
      delegate.$preInc();
      return (${STD_DUAL_ITERATOR}) this;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $postInc() {
      ${STD_DUAL_ITERATOR} cloned = clone();
      delegate.$preDec();
      return cloned;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $postDec() {
      ${STD_DUAL_ITERATOR} cloned = clone();
      delegate.$preInc();
      return cloned;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $inc(long amount) {
      delegate.$dec(amount);
      return (${STD_DUAL_ITERATOR}) this;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $dec(long amount) {
      delegate.$inc(amount);
      return (${STD_DUAL_ITERATOR}) this;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $add(long amount) {
      return new ${STD_DUAL_ITERATOR}(delegate.$sub(amount));
    }

    @Override
    public ${STD_DUAL_ITERATOR} $sub(long amount) {
      return new ${STD_DUAL_ITERATOR}(delegate.$add(amount));
    }

    @Override
    public boolean $noteq(Object other) {
      return other instanceof ${FILE_NAME} && delegate.$noteq(((${FILE_NAME}) other).delegate);
    }

    @Override
    public boolean $eq(Object other) {
      return other instanceof ${FILE_NAME} && delegate.$eq(((${FILE_NAME}) other).delegate);
    }

    @Override
    public ${STD_DUAL_ITERATOR} clone() {
      return new ${STD_DUAL_ITERATOR}(delegate.clone());
    }

    @Override
    public ${STD_DUAL_ITERATOR} const_clone() {
      return new ${STD_DUAL_ITERATOR}(delegate.const_clone());
    }

    @Override
    public ${VALUE_REFERENCE} star$ref() {
      return new ${VALUE_REFERENCE}() {

        ${VALUE_ITERATOR} localIter = delegate.clone();

        @Override
        public ${VALUE_TYPE} $deref() {
          return localIter.$star();
        }

        @Override
        public ${VALUE_TYPE} $set(${VALUE_TYPE} value) {
          return localIter.star$ref().$set(value);
        }

        @Override
        public ${VALUE_POINTER} deref$ptr() {
          return localIter.star$ref().deref$ptr();
        }
      };
    }
  }